<?php

if( !defined('EVO_MAIN_INIT') ) die( 'Please, do not access this page directly.' );



class Plugin
{
	

	
	var $name = '';

	
	var $code = '';

	
	var $priority = 50;

	
	var $version = '0';

	
	var $author = 'Unknown author';

	
	var $help_url = '';

	
	var $short_desc;

	


	

	
	var $long_desc;


	
	var $apply_rendering = 'never'; // By default, this may not be a rendering plugin


	
	var $number_of_installs;


	
	var $group;


	
	var $sub_group;


	
	var $ping_service_name;

	
	var $ping_service_note;

	


	

	
	var $classname;

	
	var $ID = 0;


	
	var $Settings;


	
	var $UserSettings;


	
	var $status;

	
	var $Plugins;

	
	var $_trans = array();

	
	var $_trans_loaded_global = false;

	


	
	function Plugin()
	{
	}


	
	function PluginInit( & $params )
	{
		// NOTE: the code below is just to handle stuff that has been deprecated since
		//       b2evolution 1.9. You don't have to include this, if you override this method.

		if( is_null($this->short_desc) )
		{ // may have been set in plugin's constructor (which is deprecated since 1.9)
			$this->short_desc = T_('No desc available');
		}
		if( is_null($this->long_desc) )
		{ // may have been set in plugin's constructor (which is deprecated since 1.9)
			$this->long_desc = T_('No description available');
		}

		if( method_exists( $this, 'AppendPluginRegister' ) && $params['is_installed'] )
		{ // Wrapper for deprecated AppendPluginRegister method (deprecated since 1.9)
			$this->debug_log('Plugin has deprecated AppendPluginRegister method. Use PluginInit instead.', array('deprecated'));

			return $this->AppendPluginRegister($params);
		}

		return true;
	}


	// Plugin information (settings, DB layout, ..): {{{

	
	function GetDefaultSettings( & $params )
	{
		return array();
	}


	
	function GetDefaultUserSettings( & $params )
	{
		return array();
	}


	
	function get_coll_setting_definitions( & $params )
	{
		return array();
	}


  
	function get_widget_param_definitions( $params )
	{
		return array();
	}


	
	function GetDependencies()
	{
		return array(); // no dependencies by default, of course
	}


	
	function GetDbLayout()
	{
		return array();
	}


	
	function GetExtraEvents()
	{
	}


	
	function GetHtsrvMethods()
	{
		return array();
	}


	
	function GetCronJobs( & $params )
	{
		return array();
	}


	
	function ExecCronJob( & $params )
	{
	}

	// }}}


	

	// Admin/backoffice events (without events specific to Items or Comments): {{{


	
	function AdminAfterEvobarInit()
	{
	}


	
	function AdminAfterMenuInit()
	{
		// Example:
		$this->register_menu_entry( $this->T_('My Tab') );
	}


	
	function AdminEndHtmlHead( & $params )
	{
		return false;		// Do nothing by default.
	}


	
	function AdminAfterPageFooter( & $params )
	{
		return false;		// Do nothing by default.
	}


	
	function AdminDisplayEditorButton( $params )
	{
		if( $params['edit_layout'] == 'simple' )
		{ // Do nothing in simple mode
			return false;
		}

		return false;		// Do nothing by default.
	}


	
	function AdminDisplayToolbar( & $params )
	{
		return false;		// Do nothing by default.
	}


	
	function AdminToolAction()
	{
	}


	
	function AdminToolPayload()
	{
		return false;		// Do nothing by default.
	}


	
	function AdminTabAction()
	{
	}


	
	function AdminTabPayload()
	{
		return false;		// Do nothing by default.
	}


	
	function AdminBeginPayload()
	{
	}

	// }}}


	// Skin/Blog events: {{{

	
	function BeforeBlogDisplay( & $params )
	{
	}


	
	function SkinBeginHtmlHead( & $params )
	{
	}


	
	function SkinEndHtmlBody( & $params )
	{
	}

	
	function SkinTag( & $params )
	{
	}

	
	function GetProvidedSkins()
	{
		return array();
	}


	
	function DisplaySkin( & $params )
	{
	}

	// }}}


	// (Un)Install / (De)Activate events: {{{

	
	function BeforeInstall()
	{
		return true;  // default is to allow Installation
	}


	
	function AfterInstall()
	{
	}


	
	function BeforeUninstall( & $params )
	{
		return true;
	}


	
	function BeforeUninstallPayload( & $params )
	{
	}


	
	function BeforeEnable()
	{
		return true;  // default is to allow Activation
	}


	
	function BeforeDisable()
	{
	}


	


	
	function PluginVersionChanged( & $params )
	{
		return true;
	}

	// }}}


	// Item events: {{{

	
	function RenderItemAsHtml( & $params )
	{
		
	}


	
	function RenderItemAsXml( & $params )
	{
		return false;		// Do nothing by default.
	}


	
	function RenderItemAsText()
	{
		return false;		// Do nothing by default.
	}


	
	function DisplayItemAsHtml( & $params )
	{
		return false;		// Do nothing by default.
	}


	
	function DisplayItemAsXml( & $params )
	{
		return false;		// Do nothing by default.
	}


	
	function DisplayItemAsText( & $params )
	{
		return false;		// Do nothing by default.
	}


	
	function PrependItemUpdateTransact( & $params )
	{
	}


	
	function AfterItemUpdate( & $params )
	{
	}


	
	function PrependItemInsertTransact( & $params )
	{
	}


	
	function AfterItemInsert( & $params )
	{
	}


	
	function AfterItemDelete( & $params )
	{
	}


	
	function AppendItemPreviewTransact( & $params )
	{
	}


	
	function ItemViewsIncreased( & $params )
	{
	}


	
	function AdminDisplayItemFormFieldset( & $params )
	{
		return false;		// Do nothing by default.
	}


	
	function AdminBeforeItemEditDelete( & $params )
	{
	}


	
	function AdminBeforeItemEditCreate( & $params )
	{
	}


	
	function AdminBeforeItemEditUpdate( & $params )
	{
	}


	
	function ItemCanComment( & $params )
	{
	}


	
	function ItemSendPing( & $params )
	{
	}


	
	function DisplayTrackbackAddr( & $params )
	{
	}


	
	function ItemApplyAsRenderer( & $params )
	{
	}

	// }}}


	// Feedback (Comment/Trackback) events: {{{

	
	function DisplayCommentToolbar( & $params )
	{
		return false;		// Do nothing by default.
	}


	
	function AdminDisplayCommentFormFieldset( & $params )
	{
		return false;		// Do nothing by default.
	}


	
	function DisplayCommentFormFieldset( & $params )
	{
	}


	
	function DisplayCommentFormButton( & $params )
	{
	}


	
	function CommentFormSent( & $params )
	{
	}


	
	function BeforeCommentFormInsert( & $params )
	{
	}


	
	function AfterCommentFormInsert( & $params )
	{
	}


	
	function GetSpamKarmaForComment( & $params )
	{
		return;
	}


	
	function AfterCommentUpdate( & $params )
	{
	}


	
	function AfterCommentInsert( & $params )
	{
	}


	
	function AfterCommentDelete( & $params )
	{
	}


	
	function BeforeTrackbackInsert( & $params )
	{
	}

	
	function AfterTrackbackInsert( & $params )
	{
	}

	
	function FilterCommentAuthor( & $params )
	{
	}


	
	function FilterCommentAuthorUrl( & $params )
	{
	}


	
	function FilterCommentContent( & $params )
	{
	}

	// }}}


	// Message form events: {{{

	
	function DisplayMessageFormFieldset( & $params )
	{
	}


	
	function DisplayMessageFormButton( & $params )
	{
	}


	
	function MessageFormSent( & $params )
	{
	}


	
	function MessageFormSentCleanup()
	{
	}

	// }}}


	// Caching events: {{{

	
	function CacheObjects( & $params )
	{
	}


	
	function CachePageContent( & $params )
	{
	}


	
	function CacheIsCollectingContent()
	{
	}

	// }}}


	// PluginSettings {{{
	
	function PluginSettingsValidateSet( & $params )
	{
	}


	
	function PluginSettingsUpdateAction()
	{
	}


	
	function PluginSettingsEditAction()
	{
	}


	
	function PluginSettingsEditDisplayAfter( & $params )
	{
	}

	// }}}


	// PluginUserSettings {{{
	
	function PluginUserSettingsValidateSet( & $params )
	{
	}


	
	function PluginUserSettingsUpdateAction( & $params )
	{
	}


	
	function PluginUserSettingsEditAction( & $params )
	{
	}


	
	function PluginUserSettingsEditDisplayAfter( & $params )
	{
	}

	// }}}


	// User related events, including registration and login (procedure): {{{

	
	function AfterLoginAnonymousUser( & $params )
	{
	}


	
	function AfterLoginRegisteredUser( & $params )
	{
	}


	
	function AppendUserRegistrTransact( & $params )
	{
		return true;
	}


	
	function AfterUserRegistration( & $params )
	{
	}


	
	function DisplayRegisterFormFieldset( & $params )
	{
	}


	
	function RegisterFormSent( & $params )
	{
	}


	
	function DisplayLoginFormFieldset( & $params )
	{
	}


	
	function LoginAttempt( & $params )
	{
	}


	
	function LoginAttemptNeedsRawPassword()
	{
		return false;
	}


	
	function Logout( $params )
	{
	}


	
	function DisplayValidateAccountFormFieldset( & $params )
	{
	}


	
	function ValidateAccountFormSent( & $params )
	{
	}


	
	function AlternateAuthentication( & $params )
	{
	}


	
	function AfterUserUpdate( & $params )
	{
	}


	
	function AfterUserInsert( & $params )
	{
	}


	
	function AfterUserDelete( & $params )
	{
	}

	// }}}


	// General events: {{{

	
	function CaptchaPayload( & $params )
	{
	}


	
	function CaptchaValidated( & $params )
	{
	}


	
	function CaptchaValidatedCleanup( & $params )
	{
	}

	// }}}


	
	function FilterIpAddress( & $params )
	{
		return false;		// Do nothing by default.
	}


	
	function SessionLoaded()
	{
	}


	
	function BeforeSessionsDelete( & $params )
	{
		return array();
	}


	
	function AppendHitLog( & $params )
	{
		// Do nothing by default:
		return false;
	}

	


	

	
	function get_class_id( $append = '' )
	{
		return $this->classname.'_id'.$this->ID.( $append ? '_'.$append : '' );
	}


	
	function T_( $string, $req_locale = '' )
	{
		global $plugins_path;

		$globalfile_path = $plugins_path.$this->classname.'/locales/_global.php';
		$trans = & $this->_trans;

		// Load the global messages file, if existing:
		if( ! $this->_trans_loaded_global )
		{
			$this->_trans_loaded_global = true;

			if( file_exists( $globalfile_path ) && is_readable( $globalfile_path ) )
			{
				include_once $globalfile_path;
			}
			else
			{
				$this->debug_log( 'Global messages file '.$globalfile_path.' does not exist or is not readable!', 'locale' );
			}
		}

		if ( ( $return = T_( $string, $req_locale, array(
								'ext_transarray' => & $this->_trans,
								'alt_basedir'    => $plugins_path.$this->classname,
							) ) ) == $string )
		{	// Fallback to global translation file:
			return T_( $string, $req_locale );
		}
		return $return;
	}


	
	function TS_( $string, $req_locale = '' )
	{
		return str_replace( "'", "\\'", $this->T_( $string, $req_locale ) );
	}


	
	function get_plugin_url( $abs = false )
	{
		global $plugins_url, $plugins_path;

		// Get sub-path below $plugins_path, if any:
		$sub_path = preg_replace( ':^'.preg_quote($plugins_path, ':').':', '', dirname($this->classfile_path).'/' );

		$r = $plugins_url.$sub_path;

		// Use the same protocol as with current host (so includes from within https do not fail when on http):
		$r = url_same_protocol($r);

		// Make it relative to current host, if absolute is not required:
		if( ! $abs )
		{
			global $ReqHost;
			$r = url_rel_to_same_host($r, $ReqHost);
		}
		return $r;
	}


	
	function debug_log( $msg, $add_cats = array() )
	{
		global $Debuglog;

		if( ! is_array($add_cats) )
		{
			$add_cats = array($add_cats);
		}

		if( ! isset($this->ID, $this->classname) )
		{ // plugin not yet instantiated. This happens, if the (deprecated) constructor of a plugin gets used.
			$add_cats[] = get_class($this).'_?';
		}
		else
		{
			$add_cats[] = $this->classname.'_'.$this->ID;
		}
		$Debuglog->add( $msg, $add_cats );
	}


	
	function get_htsrv_url( $method, $params = array(), $glue = '&amp;', $abs = false )
	{
		global $htsrv_url, $htsrv_url_sensitive;
		global $ReqHost, $Blog;

		$base = substr($ReqHost, 0, 6) == 'https:' ? $htsrv_url_sensitive : $htsrv_url;

		if( ! $abs && strpos( $base, $ReqHost ) === 0 )
		{ // cut off $ReqHost if the resulting URL starts with it:
			$base = substr($base, strlen($ReqHost));
		}

		$r = $base.'call_plugin.php?plugin_ID='.$this->ID.$glue.'method='.$method;
		if( !empty( $params ) )
		{
			$r .= $glue.'params='.rawurlencode(serialize( $params ));
		}

		return $r;
	}


	
	function msg( $msg, $category = 'note' )
	{
		global $Messages;
		$Messages->add( $msg, $category );
	}


	
	function register_menu_entry( $text, $path = 'tools', $menu_entry_props = array() )
	{
		global $AdminUI;

		$menu_entry_props['text'] = $text;
		$menu_entry_props['href'] = $this->get_tools_tab_url();

		$AdminUI->add_menu_entries( $path, array( 'plug_ID_'.$this->ID => $menu_entry_props ) );
	}


	
	function get_tools_tab_url()
	{
		global $admin_url;
		return $admin_url.'?ctrl=tools&amp;tab=plug_ID_'.$this->ID;
	}


	
	function are_events_available( $events, $by_one_plugin = false )
	{
		global $Plugins;

		return $Plugins->are_events_available( $events, $by_one_plugin );
	}


	
	function set_status( $status )
	{
		global $Plugins;

		if( ! in_array( $status, array( 'enabled', 'disabled', 'needs_config' ) ) )
		{
			return false;
		}

		return $Plugins->set_Plugin_status( $this, $status );
	}


	
	function get_sql_table( $name )
	{
		global $tableprefix;

		// NOTE: table name length seems limited to 64 chars (MySQL 5) - classname is limited to 40 (in T_plugins)
		return $tableprefix.'plugin_'.preg_replace( '#_plugin$#', '', $this->classname ).'_'.$this->ID.'_'.$name;
	}


	
	function stop_propagation()
	{
		global $Plugins;
		$Plugins->stop_propagation();
	}


	
	function session_set( $name, $value, $timeout, $save_immediately = false )
	{
		global $Session;

		$r = $Session->set( 'plugID'.$this->ID.'_'.$name, $value, $timeout );
		if( $save_immediately )
		{
			$Session->dbsave();
		}
		return $r;
	}


	
	function session_get( $name, $default = NULL )
	{
		global $Session;

		return $Session->get( 'plugID'.$this->ID.'_'.$name, $default );
	}


	
	function session_delete( $name )
	{
		global $Session;

		return $Session->delete( 'plugID'.$this->ID.'_'.$name );
	}


	
	function forget_events()
	{
		global $Plugins;
		$Plugins->forget_events( $this->ID );
	}


	
	function disable_event( $event )
	{
		$Plugins_admin = & get_Cache('Plugins_admin');
		return $Plugins_admin->set_event_status( $this->ID, $event, 0 );
	}


	
	function enable_event( $event )
	{
		$Plugins_admin = & get_Cache('Plugins_admin');
		return $Plugins_admin->set_event_status( $this->ID, $event, 1 );
	}

	


	

	
	function get_help_link( $target = '' )
	{
		static $target_counter = 0;
		$title = '';
		$icon = 'help';
		$word = '';
		$link_attribs = array( 'target' => '_blank', 'id'=>'anchor_help_plugin_'.$this->ID.'_'.$target_counter++ );

		if( $target == '$help_url' || empty($target) )
		{
			$url = '';
			$title = T_('Homepage of the plugin');
			$icon = 'www';
		}
		elseif( $target == '$readme' )
		{ // README
			if( ! $this->get_help_file() )
			{
				return '';
			}

			global $admin_url;

			$link_attribs['use_js_popup'] = true;
			$link_attribs['use_js_size'] = '500, 400';
			$title = T_('Local documentation of the plugin');
			$url = url_add_param( $admin_url, 'ctrl=plugins&amp;action=disp_help_plain&amp;plugin_class='.$this->classname );
			$icon = 'help';
		}
		elseif( substr($target, 0, 1) == '#' )
		{ // anchor
			$url = $this->get_help_url().$target;
		}
		elseif( preg_match( '~^https?://~', $target ) )
		{ // absolute URL (strict match to allow other formats later if needed)
			$url = $target;
		}
		else
		{
			debug_die( 'Invalid get_help_link() target: '.$target );
		}

		return action_icon( $title, $icon, $url, $word, 4, 1, $link_attribs );
	}


	
	function get_help_url()
	{
		if( empty( $this->help_url ) )
		{
			return 'http://manual.b2evolution.net/'.strtoupper($this->classname[0]).substr($this->classname,1);
		}
		else
		{
			return $this->help_url;
		}
	}


	
	function get_README_link()
	{
		return $this->get_help_link('$readme');
	}


	
	function get_help_file()
	{
		global $default_locale, $plugins_path, $current_User;

		if( ! $current_User->check_perm( 'options', 'view', false ) )
		{ // README gets displayed through plugins controller, which requires these perms
			// TODO: Catch "disp_help" and "disp_help_plain" messages in plugins.php before general perms check!?
			return false;
		}

		// Get the language. We use $default_locale because it does not have to be activated ($current_locale)
		$lang = substr( $default_locale, 0, 2 );

		$help_dir = dirname($this->classfile_path).'/';
		if( $help_dir == $plugins_path )
		{
			$help_dir .= $this->classname.'/';
		}

		// Try help for the user's locale:
		$help_file = $help_dir.'README.'.$lang.'.html';

		if( ! file_exists($help_file) )
		{ // Fallback: README.html
			$help_file = $help_dir.'README.html';

			if( ! file_exists($help_file) )
			{
				return false;
			}
		}

		return $help_file;
	}


	
	function get_edit_settings_link()
	{
		global $current_User, $admin_url;

		if( ! $current_User->check_perm( 'options', 'view', false ) )
		{
			return false;
		}

		return action_icon( T_('Edit plugin settings!'), 'edit', $admin_url.'?ctrl=plugins&amp;action=edit_settings&amp;plugin_ID='.$this->ID );
	}


	
	function & __get( $nm )
	{
		global $inc_path;
		global $Plugins;

		switch( $nm )
		{
			case 'Settings':
				if( $this->ID < 0 )
				{
					debug_die('Tried to access "Settings" on a non-installed plugin. ('.$this->classname.'/'.$this->ID.')');
				}
				$Plugins->instantiate_Settings( $this, 'Settings' );
				if( isset($this->Settings) )
				{
					return $this->Settings;
				}
				break;

			case 'UserSettings':
				if( $this->ID < 0 )
				{
					debug_die('Tried to access "UserSettings" on a non-installed plugin. ('.$this->classname.'/'.$this->ID.')');
				}
				$Plugins->instantiate_Settings( $this, 'UserSettings' );
				if( isset($this->UserSettings) )
				{
					return $this->UserSettings;
				}
				break;
		}
		$r = null;
		return $r;
	}

	

	
	function get_coll_setting( $parname, & $Blog )
	{
		// Name of the setting in the blog settings:
		$blog_setting_name = 'plugin'.$this->ID.'_'.$parname;

		$value = $Blog->get_setting( $blog_setting_name );

		if( ! is_null( $value ) )
		{	// We have a value for this param:
			return $value;
		}

		// Try default values:
		$params = $this->get_coll_setting_definitions( $tmp_params = array('for_editing'=>true) );
		if( isset( $params[$parname]['defaultvalue'] ) )
		{	// We ahve a default value:
			return $params[$parname]['defaultvalue'] ;
		}

		return NULL;
	}


	
	function set_coll_setting( $parname, $parvalue )
	{
		
		global $Blog;

		// Name of the setting in the blog settings:
		$blog_setting_name = 'plugin'.$this->ID.'_'.$parname;
		$Blog->set_setting( $blog_setting_name, $parvalue );
	}


}



?>
