<?php

if( !defined('EVO_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

load_class( 'widgets/model/_widget.class.php' );


class coll_longdesc_Widget extends ComponentWidget
{
	
	function coll_longdesc_Widget( $db_row = NULL )
	{
		// Call parent constructor:
		parent::ComponentWidget( $db_row, 'core', 'coll_longdesc' );
	}


	
	function get_name()
	{
		return T_('Long Description of this Blog');
	}


	
	function get_short_desc()
	{
		return format_to_output($this->disp_params['title']);
	}


  
	function get_desc()
	{
		global $Blog;
		return sprintf( T_('Long description from the blog\'s <a %s>general settings</a>.'),
						'href="?ctrl=coll_settings&tab=general&blog='.$Blog->ID.'"' );
	}


  
	function get_param_definitions( $params )
	{
		$r = array_merge( array(
				'title' => array(
					'label' => t_('Block title'),
					'note' => T_( 'Title to display in your skin.' ),
					'size' => 40,
					'defaultvalue' => '',
				),

			), parent::get_param_definitions( $params )	);

		return $r;
	}


	
	function display( $params )
	{
		global $Blog;

		$this->init_display( $params );

		// Collection long description:
		echo $this->disp_params['block_start'];

		// Display title if requested
		$title = ''.$Blog->dget( 'name', 'htmlbody' )
							.'';
		$this->disp_title( $title );

		$Blog->disp( 'longdesc', 'htmlbody' );

		echo $this->disp_params['block_end'];

		return true;
	}
}



?>