<?php

if( !defined('EVO_MAIN_INIT') ) die( 'Please, do not access this page directly.' );


class custom_Skin extends Skin
{
  
	function get_default_name()
	{
		return 'custom';
	}


  
	function get_default_type()
	{
		return 'normal';
	}


	
	function get_param_definitions( $params )
	{
		$r = array_merge( array(
		
				'logo_bg_image' => array(
					'label' => T_('Logo Background Image'),
					'note' => T_('E-g: http://example.com/image.jpg'),
					'defaultvalue' => '',
				),
				'page_bg_image' => array(
					'label' => T_('Page Background Image'),
					'note' => T_('E-g: http://example.com/image.jpg'),
					'defaultvalue' => '',
				),
				'page_bg_repeat' => array(
					'label' => T_('Page Background repeat'),
					'note' => T_('E-g: repeat-x or repeat-y or no-repeat'),
					'defaultvalue' => '',
				),
				'page_bg_color' => array(
					'label' => T_('Page Background Color'),
					'note' => T_('E-g: #ff0000 for red'),
					'defaultvalue' => '',
					'valid_pattern' => array( 'pattern'=>'^(#([a-f0-9]{3}){1,2})?$i',
																		'error'=>T_('Invalid color code.') ),
				),
				'top_bg_image' => array(
					'label' => T_('Top Background Image'),
					'note' => T_('E-g: http://example.com/image.jpg'),
					'defaultvalue' => '',
				),
				'head_bg_image' => array(
					'label' => T_('Header Background Image'),
					'note' => T_('E-g: http://example.com/image.jpg'),
					'defaultvalue' => '',
				),
				'head_bg_color' => array(
					'label' => T_('Header Background Color'),
					'note' => T_('E-g: #ff0000 for red'),
					'defaultvalue' => '',
					'valid_pattern' => array( 'pattern'=>'^(#([a-f0-9]{3}){1,2})?$i',
																		'error'=>T_('Invalid color code.') ),
				),
	
				'sidebar_bg_image' => array(
					'label' => T_('Sidebar Background Image'),
					'note' => T_('E-g: http://example.com/image.jpg'),
					'defaultvalue' => '',
				),
				'bottom_bg_image' => array(
					'label' => T_('Bottom Background Image'),
					'note' => T_('E-g: http://example.com/image.jpg'),
					'defaultvalue' => '',
				),
			), parent::get_param_definitions( $params )	);

		return $r;
	}


	
	function display_init()
	{
		// call parent:
		parent::display_init();

		// Add custom CSS:
		$custom_css = '';
		
		if( $bg_image = $this->get_setting( 'logo_bg_image') )
		{	// custom Header background color:
			$custom_css .= '	.header1 { background-image: url('.$bg_image.") }\n";
		}
		
		if( $bg_image = $this->get_setting( 'page_bg_image') )
		{	// custom Header background color:
			$custom_css .= '	body { background-image: url('.$bg_image.") }\n";
		}
		
		if( $bg_color = $this->get_setting( 'page_bg_color') )
		{	// custom Header background color:
			$custom_css .= '	body { background-color: '.$bg_color." }\n";
		}
		
		if( $bg_repeat = $this->get_setting( 'page_bg_repeat') )
		{	// custom Header background color:
			$custom_css .= '	body { background-repeat: '.$bg_repeat." }\n";
		}
		
		if( $bg_image = $this->get_setting( 'top_bg_image') )
		{	// custom Header background color:
			$custom_css .= '	.wrapper1 { background-image: url('.$bg_image.") }\n";
		}
		
		if( $bg_image = $this->get_setting( 'head_bg_image') )
		{	// custom Header background color:
			$custom_css .= '	div.pageHeader { background-image: url('.$bg_image.") }\n";
		}
		
		if( $bg_color = $this->get_setting( 'head_bg_color') )
		{	// custom Header background color:
			$custom_css .= '	div.pageHeader { background-color: '.$bg_color." }\n";
		}
		

		if( $bg_image = $this->get_setting( 'sidebar_bg_image') )
		{	// custom Meu background color:
			$custom_css .= '	.block1 { background-image: url('.$bg_image.") }\n";
		}
		
		if( $bg_image = $this->get_setting( 'bottom_bg_image') )
		{	// custom Meu background color:
			$custom_css .= '	.block3 { background-image: url('.$bg_image.") }\n";
		}

		if( !empty( $custom_css ) )
		{
			$custom_css = '
	<style type="text/css">
	<!--
'.$custom_css.'	-->
	</style>';
			add_headline( $custom_css );
		}

	}

}


?>
